Index: src/org/jboss/tools/ws/ui/wizards/JBossWSGenerateWizard.java
===================================================================
--- src/org/jboss/tools/ws/ui/wizards/JBossWSGenerateWizard.java	(revision 44607)
+++ src/org/jboss/tools/ws/ui/wizards/JBossWSGenerateWizard.java	(working copy)
@@ -35,6 +35,7 @@
 import org.eclipse.ui.PartInitException;
 import org.eclipse.ui.ide.IDE;
 import org.eclipse.ui.wizards.newresource.BasicNewResourceWizard;
+import org.jboss.tools.common.ui.CommonUIImages;
 import org.jboss.tools.ws.creation.core.commands.MergeWebXMLCommand;
 import org.jboss.tools.ws.creation.core.commands.ServiceSampleCreationCommand;
 import org.jboss.tools.ws.creation.core.data.ServiceModel;
@@ -76,6 +77,7 @@
 		JBossWSGenerateWizardPage onePage =
 			new JBossWSGenerateWizardPage("onePage"); //$NON-NLS-1$
 		addPage(onePage);
+		setDefaultPageImageDescriptor(CommonUIImages.getInstance().getOrCreateImageDescriptor(CommonUIImages.WEB_SERVICE_IMAGE));
 	}
 
 	@Override
Index: src/org/jboss/tools/ws/ui/wizards/JBossRSGenerateWizard.java
===================================================================
--- src/org/jboss/tools/ws/ui/wizards/JBossRSGenerateWizard.java	(revision 44607)
+++ src/org/jboss/tools/ws/ui/wizards/JBossRSGenerateWizard.java	(working copy)
@@ -34,6 +34,7 @@
 import org.eclipse.ui.PartInitException;
 import org.eclipse.ui.ide.IDE;
 import org.eclipse.ui.wizards.newresource.BasicNewResourceWizard;
+import org.jboss.tools.common.ui.CommonUIImages;
 import org.jboss.tools.ws.creation.core.commands.AddRestEasyJarsCommand;
 import org.jboss.tools.ws.creation.core.commands.RSMergeWebXMLCommand;
 import org.jboss.tools.ws.creation.core.commands.RSServiceSampleCreationCommand;
@@ -77,6 +78,7 @@
 		super();
 		super.setWindowTitle(JBossWSUIMessages.JBossRSGenerateWizard_RS_Wizard_Window_Title);
 		super.setHelpAvailable(false);
+		setDefaultPageImageDescriptor(CommonUIImages.getInstance().getOrCreateImageDescriptor(CommonUIImages.WEB_SERVICE_IMAGE));
 	}
 
 	public void addPages() {
Index: src/org/jboss/tools/ws/ui/wizards/JBossWSAnnotatedClassWizard.java
===================================================================
--- src/org/jboss/tools/ws/ui/wizards/JBossWSAnnotatedClassWizard.java	(revision 44607)
+++ src/org/jboss/tools/ws/ui/wizards/JBossWSAnnotatedClassWizard.java	(working copy)
@@ -35,6 +35,7 @@
 import org.eclipse.ui.ide.IDE;
 import org.eclipse.ui.wizards.newresource.BasicNewResourceWizard;
 import org.eclipse.wst.common.frameworks.datamodel.AbstractDataModelOperation;
+import org.jboss.tools.common.ui.CommonUIImages;
 import org.jboss.tools.ws.creation.core.commands.AddRestEasyJarsCommand;
 import org.jboss.tools.ws.creation.core.commands.MergeWebXMLCommand;
 import org.jboss.tools.ws.creation.core.commands.RSMergeWebXMLCommand;
@@ -83,6 +84,7 @@
 		super();
 		super.setWindowTitle(JBossWSUIMessages.JBossWSAnnotatedClassWizard_Annotated_Class_WS_Wizard_Title);
 		super.setHelpAvailable(false);
+		setDefaultPageImageDescriptor(CommonUIImages.getInstance().getOrCreateImageDescriptor(CommonUIImages.WEB_SERVICE_IMAGE));
 	}
 
 	public void addPages() {
Index: src/org/jboss/tools/jsf/ui/wizard/project/ImportJSFWarWizard.java
===================================================================
--- src/org/jboss/tools/jsf/ui/wizard/project/ImportJSFWarWizard.java	(revision 44607)
+++ src/org/jboss/tools/jsf/ui/wizard/project/ImportJSFWarWizard.java	(working copy)
@@ -10,21 +10,20 @@
  ******************************************************************************/ 
 package org.jboss.tools.jsf.ui.wizard.project;
 
-import org.jboss.tools.common.model.ui.wizards.MessageWizardPage;
 import org.eclipse.jface.operation.IRunnableWithProgress;
-
 import org.jboss.tools.common.meta.key.WizardKeys;
 import org.jboss.tools.common.model.XModelFactory;
+import org.jboss.tools.common.model.ui.wizards.MessageWizardPage;
+import org.jboss.tools.jsf.ui.JsfUiImages;
 import org.jboss.tools.jsf.ui.operation.ImportJSFWarOperation;
 import org.jboss.tools.jsf.web.helpers.context.ImportJSFWarContext;
-import org.jboss.tools.common.model.ui.ModelUIImages;
 import org.jboss.tools.jst.web.ui.wizards.project.ImportWebWarWizard;
 
 public class ImportJSFWarWizard extends ImportWebWarWizard {
 
 	public ImportJSFWarWizard() {
 		this.setWindowTitle(WizardKeys.getString(ImportProjectWizard.IMPORT_JSF_PROJECT_WIZARD_WINDOW_TITLE));
-		this.setDefaultPageImageDescriptor(ModelUIImages.getImageDescriptor(ModelUIImages.WIZARD_IMPORT_PROJECT));
+		this.setDefaultPageImageDescriptor(JsfUiImages.getImageDescriptor(JsfUiImages.IMPORT_JSF_PROJECT_WIZARD));
 	}
 	
 	public void addPages() {
Index: src/org/jboss/tools/jsf/ui/wizard/project/NewProjectWizard.java
===================================================================
--- src/org/jboss/tools/jsf/ui/wizard/project/NewProjectWizard.java	(revision 44607)
+++ src/org/jboss/tools/jsf/ui/wizard/project/NewProjectWizard.java	(working copy)
@@ -15,9 +15,9 @@
 import org.eclipse.swt.widgets.Composite;
 import org.eclipse.ui.PlatformUI;
 import org.jboss.tools.common.meta.key.WizardKeys;
-import org.jboss.tools.common.model.ui.ModelUIImages;
 import org.jboss.tools.jsf.JSFPreference;
 import org.jboss.tools.jsf.ui.IJSFHelpContextIds;
+import org.jboss.tools.jsf.ui.JsfUiImages;
 import org.jboss.tools.jsf.ui.operation.JSFProjectCreationOperation;
 import org.jboss.tools.jsf.web.helpers.context.NewProjectWizardContext;
 import org.jboss.tools.jst.web.project.helpers.ProjectTemplate;
@@ -35,7 +35,7 @@
 	public NewProjectWizard() {
 		context = new NewProjectWizardContext();
 		this.setWindowTitle(WizardKeys.getString(NEW_JSF_PROJECT_WIZARD_WINDOW_TITLE));
-		this.setDefaultPageImageDescriptor(ModelUIImages.getImageDescriptor(ModelUIImages.WIZARD_NEW_PROJECT));
+		this.setDefaultPageImageDescriptor(JsfUiImages.getImageDescriptor(JsfUiImages.JSF_PROJECT_WIZARD));
 	}
 	
 	public void createPageControls(Composite parent) {
Index: src/org/jboss/tools/jsf/ui/wizard/project/ImportProjectWizard.java
===================================================================
--- src/org/jboss/tools/jsf/ui/wizard/project/ImportProjectWizard.java	(revision 44607)
+++ src/org/jboss/tools/jsf/ui/wizard/project/ImportProjectWizard.java	(working copy)
@@ -16,9 +16,9 @@
 import org.jboss.tools.common.meta.key.WizardKeys;
 import org.jboss.tools.common.model.XModelFactory;
 import org.jboss.tools.jsf.ui.IJSFHelpContextIds;
+import org.jboss.tools.jsf.ui.JsfUiImages;
 import org.jboss.tools.jsf.ui.operation.JSFProjectAdoptOperation;
-import org.jboss.tools.jsf.web.helpers.context.*;
-import org.jboss.tools.common.model.ui.*;
+import org.jboss.tools.jsf.web.helpers.context.ImportProjectWizardContext;
 import org.jboss.tools.jst.web.ui.wizards.project.ImportWebProjectWizard;
 
 public class ImportProjectWizard extends ImportWebProjectWizard {
@@ -27,7 +27,7 @@
 	
 	public ImportProjectWizard() {
 		this.setWindowTitle(WizardKeys.getString(IMPORT_JSF_PROJECT_WIZARD_WINDOW_TITLE));
-		this.setDefaultPageImageDescriptor(ModelUIImages.getImageDescriptor(ModelUIImages.WIZARD_IMPORT_PROJECT));
+		this.setDefaultPageImageDescriptor(JsfUiImages.getImageDescriptor(JsfUiImages.IMPORT_JSF_PROJECT_WIZARD));
 	}
 	
 	public void createPageControls(Composite parent) {
Index: src/org/jboss/tools/jsf/ui/wizard/newfile/NewFacesConfigFileWizard.java
===================================================================
--- src/org/jboss/tools/jsf/ui/wizard/newfile/NewFacesConfigFileWizard.java	(revision 44607)
+++ src/org/jboss/tools/jsf/ui/wizard/newfile/NewFacesConfigFileWizard.java	(working copy)
@@ -10,14 +10,18 @@
  ******************************************************************************/ 
 package org.jboss.tools.jsf.ui.wizard.newfile;
 
-import org.eclipse.swt.widgets.Composite;
-import org.eclipse.ui.PlatformUI;
 import org.jboss.tools.common.meta.action.impl.SpecialWizardSupport;
+import org.jboss.tools.common.model.ui.wizard.newfile.NewFileContextEx;
+import org.jboss.tools.common.model.ui.wizard.newfile.NewFileWizardEx;
 import org.jboss.tools.jsf.model.handlers.CreateFacesConfigSupport;
-import org.jboss.tools.jsf.ui.IJSFHelpContextIds;
-import org.jboss.tools.common.model.ui.wizard.newfile.*;
+import org.jboss.tools.jsf.ui.JsfUiImages;
 
 public class NewFacesConfigFileWizard extends NewFileWizardEx {
+	
+	public NewFacesConfigFileWizard(){
+		super();
+		setDefaultPageImageDescriptor(JsfUiImages.getImageDescriptor(JsfUiImages.FACES_CONFIG_WIZARD));
+	}
 
 	protected NewFileContextEx createNewFileContext() {
 		return new NewFacesConfigFileContext();
Index: src/org/jboss/tools/jsf/ui/JsfUiImages.java
===================================================================
--- src/org/jboss/tools/jsf/ui/JsfUiImages.java	(revision 44607)
+++ src/org/jboss/tools/jsf/ui/JsfUiImages.java	(working copy)
@@ -21,6 +21,9 @@
 	
 	public static String JSF_IMPORT_PROJECT_ACTION = "wizards/import_jsf_project.gif"; //$NON-NLS-1$
 	public static String JSF_CREATE_PROJECT_ACTION = "wizards/new_jsf_project.gif"; //$NON-NLS-1$
+	public static String JSF_PROJECT_WIZARD = "wizards/JSFProjectWizBan.png"; //$NON-NLS-1$
+	public static String IMPORT_JSF_PROJECT_WIZARD = "wizards/ImportJSFProjectWizBan.png"; //$NON-NLS-1$
+	public static String FACES_CONFIG_WIZARD = "wizards/FacesConfigWizBan.png"; //$NON-NLS-1$
 	
 	private static JsfUiImages INSTANCE;
 	
Index: src/org/jboss/tools/jst/web/ui/JSTWebUIImages.java
===================================================================
--- src/org/jboss/tools/jst/web/ui/JSTWebUIImages.java	(revision 0)
+++ src/org/jboss/tools/jst/web/ui/JSTWebUIImages.java	(revision 0)
@@ -0,0 +1,49 @@
+/******************************************************************************* 
+ * Copyright (c) 2012 Red Hat, Inc. 
+ * Distributed under license by Red Hat, Inc. All rights reserved. 
+ * This program is made available under the terms of the 
+ * Eclipse Public License v1.0 which accompanies this distribution, 
+ * and is available at http://www.eclipse.org/legal/epl-v10.html 
+ * 
+ * Contributors: 
+ * Red Hat, Inc. - initial API and implementation 
+ ******************************************************************************/ 
+package org.jboss.tools.jst.web.ui;
+
+import java.net.MalformedURLException;
+import java.net.URL;
+
+import org.jboss.tools.common.ui.CommonUIImages;
+
+public class JSTWebUIImages extends CommonUIImages{
+	private static String WIZARDS_PATH         = "wizards/"; //$NON-NLS-1$
+	
+	public static String CSS_FILE_IMAGE    = WIZARDS_PATH + "CSSFileWizBan.png"; //$NON-NLS-1$
+	public static String DATASOURCE_IMAGE    = WIZARDS_PATH + "DatasourceWizBan.png"; //$NON-NLS-1$
+	public static String TLD_FILE_IMAGE    = WIZARDS_PATH + "TLDFileWizBan.png"; //$NON-NLS-1$
+	public static String WEB_DESCRIPTOR_IMAGE    = WIZARDS_PATH + "WebDescriptorWizBan.png"; //$NON-NLS-1$
+	public static String TILES_FILE_IMAGE    = WIZARDS_PATH + "TilesFileWizBan.png"; //$NON-NLS-1$
+
+	private static JSTWebUIImages INSTANCE;
+	
+	static {
+		try {
+			INSTANCE = new JSTWebUIImages(new URL(WebUiPlugin.getDefault().getBundle().getEntry("/"), "images/xstudio/")); //$NON-NLS-1$ //$NON-NLS-2$
+		} catch (MalformedURLException e) {
+			// do nothing
+			WebUiPlugin.getPluginLog().logError(e);
+		}
+	}
+	
+	public static JSTWebUIImages getInstance() {
+		return INSTANCE;
+	}
+	
+	protected JSTWebUIImages(URL registryUrl, JSTWebUIImages parent){
+		super(registryUrl, parent);
+	}
+	
+	protected JSTWebUIImages(URL url){
+		this(url,null);		
+	}
+}
Index: src/org/jboss/tools/jst/web/ui/wizards/newfile/NewWebFileWizard.java
===================================================================
--- src/org/jboss/tools/jst/web/ui/wizards/newfile/NewWebFileWizard.java	(revision 44607)
+++ src/org/jboss/tools/jst/web/ui/wizards/newfile/NewWebFileWizard.java	(working copy)
@@ -11,9 +11,15 @@
 package org.jboss.tools.jst.web.ui.wizards.newfile;
 
 import org.jboss.tools.common.model.ui.wizard.newfile.*;
+import org.jboss.tools.jst.web.ui.JSTWebUIImages;
 
 public class NewWebFileWizard extends NewFileWizardEx {
 
+	public NewWebFileWizard(){
+		super();
+		setDefaultPageImageDescriptor(JSTWebUIImages.getInstance().getOrCreateImageDescriptor(JSTWebUIImages.WEB_DESCRIPTOR_IMAGE));
+	}
+	
 	protected NewFileContextEx createNewFileContext() {
 		return new NewWebFileContext();
 	}
Index: src/org/jboss/tools/jst/web/ui/wizards/newfile/NewTLDFileWizard.java
===================================================================
--- src/org/jboss/tools/jst/web/ui/wizards/newfile/NewTLDFileWizard.java	(revision 44607)
+++ src/org/jboss/tools/jst/web/ui/wizards/newfile/NewTLDFileWizard.java	(working copy)
@@ -13,9 +13,15 @@
 import org.jboss.tools.common.meta.action.impl.SpecialWizardSupport;
 import org.jboss.tools.common.model.ui.wizard.newfile.*;
 import org.jboss.tools.jst.web.tld.model.handlers.CreateTLDFileSupport;
+import org.jboss.tools.jst.web.ui.JSTWebUIImages;
 
 public class NewTLDFileWizard extends NewFileWizardEx {
-
+	
+	public NewTLDFileWizard(){
+		super();
+		setDefaultPageImageDescriptor(JSTWebUIImages.getInstance().getOrCreateImageDescriptor(JSTWebUIImages.TLD_FILE_IMAGE));
+	}
+	
 	protected NewFileContextEx createNewFileContext() {
 		return new NewWebFileContext();
 	}
Index: src/org/jboss/tools/jst/web/ui/wizards/newfile/NewDSXMLWizard.java
===================================================================
--- src/org/jboss/tools/jst/web/ui/wizards/newfile/NewDSXMLWizard.java	(revision 44607)
+++ src/org/jboss/tools/jst/web/ui/wizards/newfile/NewDSXMLWizard.java	(working copy)
@@ -106,6 +106,7 @@
 import org.jboss.tools.common.ui.widget.editor.ITaggedFieldEditor;
 import org.jboss.tools.common.util.FileUtil;
 import org.jboss.tools.common.zip.UnzipOperation;
+import org.jboss.tools.jst.web.ui.JSTWebUIImages;
 import org.jboss.tools.jst.web.ui.Messages;
 import org.jboss.tools.jst.web.ui.WebUiPlugin;
 import org.osgi.framework.Bundle;
@@ -122,7 +123,7 @@
 
 	private boolean fOpenEditorOnFinish = true;
 
-	public NewDSXMLWizard() {		
+	public NewDSXMLWizard() {
 	}
 
 	public void init(IWorkbench workbench, IStructuredSelection currentSelection) {
@@ -220,6 +221,7 @@
 		public WizardNewDSXMLFileCreationPage(String pageName, IStructuredSelection selection) {
 			super(pageName);
 			setPageComplete(false);
+			setDefaultPageImageDescriptor(JSTWebUIImages.getInstance().getOrCreateImageDescriptor(JSTWebUIImages.DATASOURCE_IMAGE));
 		}
 
 		public IPath getContainerFullPath() {
Index: src/org/jboss/tools/common/ui/CommonUIImages.java
===================================================================
--- src/org/jboss/tools/common/ui/CommonUIImages.java	(revision 44607)
+++ src/org/jboss/tools/common/ui/CommonUIImages.java	(working copy)
@@ -32,6 +32,7 @@
 
 	public static final String JAVA_SERVICE_PROVIDER_IMAGE = "wizard/JavaServiceProviderWizBan.png"; //$NON-NLS-1$
 	public static final String NEW_JAVA_SERVICE_PROVIDER_IMAGE = "wizard/NewJavaServiceProviderWizBan.png"; //$NON-NLS-1$
+	public static final String WEB_SERVICE_IMAGE = "wizard/WebServiceWizBan.png"; //$NON-NLS-1$
 
 	public final static Image getImage(ImageDescriptor descriptor) {
 		return CommonUIPlugin.getImageDescriptorRegistry().get(descriptor);
Index: src/org/jboss/tools/jst/css/wizard/NewCSSClassWizard.java
===================================================================
--- src/org/jboss/tools/jst/css/wizard/NewCSSClassWizard.java	(revision 44607)
+++ src/org/jboss/tools/jst/css/wizard/NewCSSClassWizard.java	(working copy)
@@ -29,6 +29,7 @@
 import org.eclipse.ui.IWorkbenchWizard;
 import org.jboss.tools.jst.css.dialog.CSSClassDialog;
 import org.jboss.tools.jst.css.messages.CSSUIMessages;
+import org.jboss.tools.jst.web.ui.JSTWebUIImages;
 
 /**
  * New CSS class wizard.
@@ -51,6 +52,7 @@
 	 */
 	public NewCSSClassWizard() {
 		setWindowTitle(CSSUIMessages.WIZARD_WINDOW_TITLE);
+		setDefaultPageImageDescriptor(JSTWebUIImages.getInstance().getOrCreateImageDescriptor(JSTWebUIImages.CSS_FILE_IMAGE));
 	}
 
 	/**
Index: src/org/jboss/tools/jst/web/tiles/ui/wizard/newfile/NewTilesFileWizard.java
===================================================================
--- src/org/jboss/tools/jst/web/tiles/ui/wizard/newfile/NewTilesFileWizard.java	(revision 44607)
+++ src/org/jboss/tools/jst/web/tiles/ui/wizard/newfile/NewTilesFileWizard.java	(working copy)
@@ -13,8 +13,14 @@
 import org.jboss.tools.common.meta.action.impl.SpecialWizardSupport;
 import org.jboss.tools.common.model.ui.wizard.newfile.*;
 import org.jboss.tools.jst.web.tiles.model.handlers.CreateTilesSupport;
+import org.jboss.tools.jst.web.ui.JSTWebUIImages;
 
 public class NewTilesFileWizard extends NewFileWizardEx {
+	
+	public NewTilesFileWizard(){
+		super();
+		setDefaultPageImageDescriptor(JSTWebUIImages.getInstance().getOrCreateImageDescriptor(JSTWebUIImages.TILES_FILE_IMAGE));
+	}
 
 	protected NewFileContextEx createNewFileContext() {
 		return new NewTilesFileContext();
Index: src/org/jboss/tools/struts/ui/StrutsUIImages.java
===================================================================
--- src/org/jboss/tools/struts/ui/StrutsUIImages.java	(revision 0)
+++ src/org/jboss/tools/struts/ui/StrutsUIImages.java	(revision 0)
@@ -0,0 +1,48 @@
+/******************************************************************************* 
+ * Copyright (c) 2012 Red Hat, Inc. 
+ * Distributed under license by Red Hat, Inc. All rights reserved. 
+ * This program is made available under the terms of the 
+ * Eclipse Public License v1.0 which accompanies this distribution, 
+ * and is available at http://www.eclipse.org/legal/epl-v10.html 
+ * 
+ * Contributors: 
+ * Red Hat, Inc. - initial API and implementation 
+ ******************************************************************************/ 
+package org.jboss.tools.struts.ui;
+
+import java.net.MalformedURLException;
+import java.net.URL;
+
+import org.jboss.tools.common.ui.CommonUIImages;
+
+public class StrutsUIImages extends CommonUIImages{
+	private static String WIZARDS_PATH         = "wizards/"; //$NON-NLS-1$
+	
+	public static String STRUTS_CONFIG_IMAGE    = WIZARDS_PATH + "StrutsConfigWizBan.png"; //$NON-NLS-1$
+	public static String STRUTS_PROJECT_IMAGE    = WIZARDS_PATH + "StrutsProjectWizBan.png"; //$NON-NLS-1$
+	public static String IMPORT_STRUTS_PROJECT_IMAGE    = WIZARDS_PATH + "ImportStrutsProjectWizBan.png"; //$NON-NLS-1$
+	public static String VALIDATION_FILE_IMAGE    = WIZARDS_PATH + "ValidationFileWizBan.png"; //$NON-NLS-1$
+
+	private static StrutsUIImages INSTANCE;
+	
+	static {
+		try {
+			INSTANCE = new StrutsUIImages(new URL(StrutsUIPlugin.getDefault().getBundle().getEntry("/"), "images/xstudio/")); //$NON-NLS-1$ //$NON-NLS-2$
+		} catch (MalformedURLException e) {
+			// do nothing
+			StrutsUIPlugin.getPluginLog().logError(e);
+		}
+	}
+	
+	public static StrutsUIImages getInstance() {
+		return INSTANCE;
+	}
+	
+	protected StrutsUIImages(URL registryUrl, StrutsUIImages parent){
+		super(registryUrl, parent);
+	}
+	
+	protected StrutsUIImages(URL url){
+		this(url,null);		
+	}
+}
Index: src/org/jboss/tools/struts/ui/wizard/project/ImportStrutsWarWizard.java
===================================================================
--- src/org/jboss/tools/struts/ui/wizard/project/ImportStrutsWarWizard.java	(revision 44607)
+++ src/org/jboss/tools/struts/ui/wizard/project/ImportStrutsWarWizard.java	(working copy)
@@ -13,16 +13,16 @@
 import org.eclipse.jface.operation.IRunnableWithProgress;
 import org.jboss.tools.common.meta.key.WizardKeys;
 import org.jboss.tools.common.model.XModelFactory;
-import org.jboss.tools.common.model.ui.ModelUIImages;
-import org.jboss.tools.struts.ui.operation.ImportStrutsWarOperation;
 import org.jboss.tools.jst.web.ui.wizards.project.ImportWebWarWizard;
+import org.jboss.tools.struts.ui.StrutsUIImages;
+import org.jboss.tools.struts.ui.operation.ImportStrutsWarOperation;
 import org.jboss.tools.struts.webprj.model.helpers.context.ImportStrutsWarContext;
 
 public class ImportStrutsWarWizard extends ImportWebWarWizard {
 
 	public ImportStrutsWarWizard() {
 		this.setWindowTitle(WizardKeys.getString(ImportProjectWizard.IMPORT_STRUTS_PROJECT_WIZARD_WINDOW_TITLE));
-		this.setDefaultPageImageDescriptor(ModelUIImages.getImageDescriptor(ModelUIImages.WIZARD_IMPORT_PROJECT));
+		this.setDefaultPageImageDescriptor(StrutsUIImages.getInstance().getOrCreateImageDescriptor(StrutsUIImages.IMPORT_STRUTS_PROJECT_IMAGE));
 	}
 
 	public void addPages() {
Index: src/org/jboss/tools/struts/ui/wizard/project/ImportProjectWizard.java
===================================================================
--- src/org/jboss/tools/struts/ui/wizard/project/ImportProjectWizard.java	(revision 44607)
+++ src/org/jboss/tools/struts/ui/wizard/project/ImportProjectWizard.java	(working copy)
@@ -10,15 +10,15 @@
  ******************************************************************************/ 
 package org.jboss.tools.struts.ui.wizard.project;
 
-import org.jboss.tools.common.model.ui.util.ModelUtilities;
 import org.eclipse.jface.operation.IRunnableWithProgress;
 import org.eclipse.swt.widgets.Composite;
 import org.eclipse.ui.PlatformUI;
 import org.jboss.tools.common.meta.key.WizardKeys;
-import org.jboss.tools.common.model.ui.ModelUIImages;
+import org.jboss.tools.common.model.ui.util.ModelUtilities;
+import org.jboss.tools.jst.web.ui.wizards.project.ImportWebProjectWizard;
 import org.jboss.tools.struts.ui.IStrutsHelpContextIds;
+import org.jboss.tools.struts.ui.StrutsUIImages;
 import org.jboss.tools.struts.ui.operation.StrutsProjectAdoptOperation;
-import org.jboss.tools.jst.web.ui.wizards.project.ImportWebProjectWizard;
 import org.jboss.tools.struts.webprj.model.helpers.context.ImportProjectWizardContext;
 
 public class ImportProjectWizard extends ImportWebProjectWizard {
@@ -30,7 +30,7 @@
 	
 	public ImportProjectWizard() {
 		this.setWindowTitle(WizardKeys.getString(IMPORT_STRUTS_PROJECT_WIZARD_WINDOW_TITLE));
-		this.setDefaultPageImageDescriptor(ModelUIImages.getImageDescriptor(ModelUIImages.WIZARD_IMPORT_PROJECT));
+		this.setDefaultPageImageDescriptor(StrutsUIImages.getInstance().getOrCreateImageDescriptor(StrutsUIImages.IMPORT_STRUTS_PROJECT_IMAGE));
 	}
 	
 	public void createPageControls(Composite parent) {
Index: src/org/jboss/tools/struts/ui/wizard/project/NewProjectWizard.java
===================================================================
--- src/org/jboss/tools/struts/ui/wizard/project/NewProjectWizard.java	(revision 44607)
+++ src/org/jboss/tools/struts/ui/wizard/project/NewProjectWizard.java	(working copy)
@@ -19,6 +19,7 @@
 import org.jboss.tools.common.model.ui.ModelUIImages;
 import org.jboss.tools.jst.web.project.helpers.ProjectTemplate;
 import org.jboss.tools.struts.ui.IStrutsHelpContextIds;
+import org.jboss.tools.struts.ui.StrutsUIImages;
 import org.jboss.tools.struts.ui.operation.StrutsProjectCreationOperation;
 import org.jboss.tools.jst.web.WebPreference;
 import org.jboss.tools.jst.web.ui.wizards.appregister.NewProjectRegisterPage;
@@ -36,7 +37,7 @@
 	public NewProjectWizard() {
 		context = new NewProjectWizardContext();
 		this.setWindowTitle(WizardKeys.getString(NEW_STRUTS_PROJECT_WIZARD_WINDOW_TITLE));
-		this.setDefaultPageImageDescriptor(ModelUIImages.getImageDescriptor(ModelUIImages.WIZARD_NEW_PROJECT));
+		this.setDefaultPageImageDescriptor(StrutsUIImages.getInstance().getOrCreateImageDescriptor(StrutsUIImages.STRUTS_PROJECT_IMAGE));
 	}
 	
 	public void createPageControls(Composite parent) {
Index: src/org/jboss/tools/struts/ui/wizard/newfile/NewStrutsConfigFileWizard.java
===================================================================
--- src/org/jboss/tools/struts/ui/wizard/newfile/NewStrutsConfigFileWizard.java	(revision 44607)
+++ src/org/jboss/tools/struts/ui/wizard/newfile/NewStrutsConfigFileWizard.java	(working copy)
@@ -14,10 +14,13 @@
 import org.eclipse.ui.PlatformUI;
 import org.jboss.tools.common.model.ui.wizard.newfile.*;
 import org.jboss.tools.struts.ui.IStrutsHelpContextIds;
+import org.jboss.tools.struts.ui.StrutsUIImages;
 
 public class NewStrutsConfigFileWizard extends NewFileWizardEx {
 
-	public NewStrutsConfigFileWizard() {}
+	public NewStrutsConfigFileWizard() {
+		setDefaultPageImageDescriptor(StrutsUIImages.getInstance().getOrCreateImageDescriptor(StrutsUIImages.STRUTS_CONFIG_IMAGE));
+	}
 	
 	protected int getVersion() {
 		return 1;
Index: src/org/jboss/tools/struts/ui/wizard/newfile/NewValidationFile11Wizard.java
===================================================================
--- src/org/jboss/tools/struts/ui/wizard/newfile/NewValidationFile11Wizard.java	(revision 44607)
+++ src/org/jboss/tools/struts/ui/wizard/newfile/NewValidationFile11Wizard.java	(working copy)
@@ -11,8 +11,13 @@
 package org.jboss.tools.struts.ui.wizard.newfile;
 
 import org.jboss.tools.common.model.ui.wizard.newfile.*;
+import org.jboss.tools.struts.ui.StrutsUIImages;
 
 public class NewValidationFile11Wizard extends NewFileWizardEx {
+	
+	public NewValidationFile11Wizard(){
+		setDefaultPageImageDescriptor(StrutsUIImages.getInstance().getOrCreateImageDescriptor(StrutsUIImages.VALIDATION_FILE_IMAGE));
+	}
 
 	protected NewFileContextEx createNewFileContext() {
 		return new NewValidationFile11Context();
Index: src/org/jboss/tools/struts/ui/wizard/newfile/NewValidationFileWizard.java
===================================================================
--- src/org/jboss/tools/struts/ui/wizard/newfile/NewValidationFileWizard.java	(revision 44607)
+++ src/org/jboss/tools/struts/ui/wizard/newfile/NewValidationFileWizard.java	(working copy)
@@ -12,9 +12,14 @@
 
 import org.jboss.tools.common.meta.action.impl.SpecialWizardSupport;
 import org.jboss.tools.common.model.ui.wizard.newfile.*;
+import org.jboss.tools.struts.ui.StrutsUIImages;
 import org.jboss.tools.struts.validators.model.handlers.CreateValidationFileSupport;
 
 public class NewValidationFileWizard extends NewFileWizardEx {
+	
+	public NewValidationFileWizard(){
+		setDefaultPageImageDescriptor(StrutsUIImages.getInstance().getOrCreateImageDescriptor(StrutsUIImages.VALIDATION_FILE_IMAGE));
+	}
 
 	protected NewFileContextEx createNewFileContext() {
 		return new NewValidationFileContext();
Index: src/org/jboss/tools/common/model/ui/wizard/newfile/NewPropertiesFileWizard.java
===================================================================
--- src/org/jboss/tools/common/model/ui/wizard/newfile/NewPropertiesFileWizard.java	(revision 44607)
+++ src/org/jboss/tools/common/model/ui/wizard/newfile/NewPropertiesFileWizard.java	(working copy)
@@ -10,7 +10,14 @@
  ******************************************************************************/ 
 package org.jboss.tools.common.model.ui.wizard.newfile;
 
+import org.jboss.tools.common.model.ui.ModelUIImages;
+
 public class NewPropertiesFileWizard extends NewFileWizardEx {
+	
+	public NewPropertiesFileWizard(){
+		super();
+		setDefaultPageImageDescriptor(ModelUIImages.getInstance().getOrCreateImageDescriptor(ModelUIImages.PROPERTIES_FILE_IMAGE));
+	}
 
 	protected NewFileContextEx createNewFileContext() {
 		return new NewPropertiesFileContext();
Index: src/org/jboss/tools/common/model/ui/ModelUIImages.java
===================================================================
--- src/org/jboss/tools/common/model/ui/ModelUIImages.java	(revision 44607)
+++ src/org/jboss/tools/common/model/ui/ModelUIImages.java	(working copy)
@@ -30,6 +30,7 @@
 	public static String WIZARD_DEFAULT        = ACTIONS_PATH + "EclipseDefault.png"; //$NON-NLS-1$
 	public static String WIZARD_IMPORT_PROJECT = ACTIONS_PATH + "EclipseImport.png"; //$NON-NLS-1$
 	public static String WIZARD_MODULES_CONFIG = ACTIONS_PATH + "EclipseModulesConfiguration.gif"; //$NON-NLS-1$
+	public static String PROPERTIES_FILE_IMAGE    = ACTIONS_PATH + "PropertiesFileWizBan.png"; //$NON-NLS-1$
 	
 	// JAVA
 	public static String JAVA_CLASS 			= "java/class.gif"; //$NON-NLS-1$