Index: cluster/src/main/org/jboss/ha/framework/server/lock/YieldingGloballyExclusiveClusterLockSupport.java
===================================================================
--- cluster/src/main/org/jboss/ha/framework/server/lock/YieldingGloballyExclusiveClusterLockSupport.java	(revision 113708)
+++ cluster/src/main/org/jboss/ha/framework/server/lock/YieldingGloballyExclusiveClusterLockSupport.java	(working copy)
@@ -82,12 +82,17 @@
    @Override
    protected RemoteLockResponse yieldLock(ClusterLockState lockState, ClusterNode caller, long timeout)
    {
+       log.info("yieldLock() > "+getLocalClusterNode()+" - "+ lockState.getHolder() + " = "+ getLocalClusterNode().equals(lockState.getHolder()));
       if (getLocalClusterNode().equals(lockState.getHolder()))
       {
-         return getLock(lockState.lockId, lockState, caller, timeout);
+          
+          RemoteLockResponse rsp =getLock(lockState.lockId, lockState, caller, timeout);
+          log.info("yieldLock() > "+rsp);
+         return rsp;
       }
       else
       {
+         log.info("yieldLock() -> REJECT > "+new RemoteLockResponse(getLocalClusterNode(), RemoteLockResponse.Flag.REJECT, lockState.getHolder()));
          return new RemoteLockResponse(getLocalClusterNode(), RemoteLockResponse.Flag.REJECT, lockState.getHolder());
       }
    }
Index: cluster/src/main/org/jboss/ha/framework/server/lock/AbstractClusterLockSupport.java
===================================================================
--- cluster/src/main/org/jboss/ha/framework/server/lock/AbstractClusterLockSupport.java	(revision 113708)
+++ cluster/src/main/org/jboss/ha/framework/server/lock/AbstractClusterLockSupport.java	(working copy)
@@ -137,8 +137,10 @@
       
       long left = timeout > 0 ? timeout : Long.MAX_VALUE;
       long start = System.currentTimeMillis();
+      log.info("--> start: "+start); 
       while (left > 0)
       {
+         log.info("--> left: "+left); 
          // Another node we lost to who should take precedence
          // over ourself in competition for the lock
          ClusterNode superiorCompetitor = null;
@@ -235,8 +237,10 @@
          // If we've detected we are competing with someone else who is 
          // "superior" pause longer to let them proceed first.
          long backoff = computeBackoff(timeout, start, left, superiorCompetitor == null);
+         log.info("--> backoff: "+backoff); 
          if (backoff > 0)
          {
+             
             try
             {
                Thread.sleep(backoff);
@@ -257,6 +261,8 @@
          long now = System.currentTimeMillis();
          left -= (now - start);
          start = now;
+         log.info("--> new left: "+left); 
+         log.info("--> new start: "+start); 
       }
       
       return false;
@@ -543,6 +549,7 @@
    {
       try
       {
+          log.info("---> cleanup()");
          partition.callMethodOnCluster(getServiceHAName(), "releaseRemoteLock", new Object[]{categoryName, me}, RELEASE_REMOTE_LOCK_TYPES, true);
       }
       catch (RuntimeException e)
Index: testsuite/src/resources/log4j.xml
===================================================================
--- testsuite/src/resources/log4j.xml	(revision 113708)
+++ testsuite/src/resources/log4j.xml	(working copy)
@@ -21,9 +21,9 @@
   <!-- ================================= -->
 
   <!-- A time/date based rolling appender -->
-  <appender name="FILE" class="org.jboss.logging.appender.DailyRollingFileAppender">
-    <param name="File" value="${build.testlog}/test.log"/>
-    <param name="Append" value="true"/>
+  <appender name="FILE" class="org.apache.log4j.FileAppender">
+    <param name="File" value="${build.testlog}/testlog.txt"/>
+    <param name="Threshold" value="FINEST"/>
 
     <!-- Rollover at midnight each day -->
     <param name="DatePattern" value="'.'yyyy-MM-dd"/>
@@ -149,8 +149,14 @@
   <!-- ======================= -->
   <!-- Setup the Root category -->
   <!-- ======================= -->
-
+ <category name="org.jboss.test.cluster.defaultcfg.test">
+    <priority value="FINEST" />
+ </category>
+ <category name="org.jboss.ha.framework.server">
+    <priority value="FINEST" />
+ </category>
   <root>
+    <level value="FINEST"/>
     <appender-ref ref="CONSOLE"/>
     <appender-ref ref="FILE"/>
   </root>