Index: src/org/jboss/tools/openshift/express/internal/ui/wizard/application/ApplicationWizardModel.java
===================================================================
--- src/org/jboss/tools/openshift/express/internal/ui/wizard/application/ApplicationWizardModel.java	(revision 44557)
+++ src/org/jboss/tools/openshift/express/internal/ui/wizard/application/ApplicationWizardModel.java	(working copy)
@@ -10,6 +10,7 @@
  ******************************************************************************/
 package org.jboss.tools.openshift.express.internal.ui.wizard.application;
 
+import org.eclipse.core.runtime.Assert;
 import org.jboss.tools.common.ui.databinding.ObservableUIPojo;
 import org.jboss.tools.openshift.express.internal.core.connection.Connection;
 
@@ -24,6 +25,7 @@
 	private Connection connection;
 
 	public ApplicationWizardModel(IApplication application, Connection connection) {
+		Assert.isLegal(connection != null, "No/invalid connection provided");
 		this.application = application;
 		this.connection = connection;
 	}
@@ -32,7 +34,7 @@
 		return application;
 	}
 
-	public Connection getUser() {
+	public Connection getConnection() {
 		return connection;
 	}
 }
Index: src/org/jboss/tools/openshift/express/internal/ui/wizard/embed/EmbedCartridgeWizardPageModel.java
===================================================================
--- src/org/jboss/tools/openshift/express/internal/ui/wizard/embed/EmbedCartridgeWizardPageModel.java	(revision 44556)
+++ src/org/jboss/tools/openshift/express/internal/ui/wizard/embed/EmbedCartridgeWizardPageModel.java	(working copy)
@@ -54,7 +54,7 @@
 	}
 	
 	public List<IEmbeddableCartridge> loadEmbeddableCartridges() throws OpenShiftException, SocketTimeoutException {
-		List<IEmbeddableCartridge> cartridges = wizardModel.getUser().getEmbeddableCartridges();
+		List<IEmbeddableCartridge> cartridges = wizardModel.getConnection().getEmbeddableCartridges();
 		setEmbeddableCartridges(cartridges);
 		return cartridges;
 	}
@@ -94,7 +94,7 @@
 	}
 	
 	public boolean hasApplication(ICartridge cartridge) throws SocketTimeoutException, OpenShiftException {
-		return wizardModel.getUser().hasApplicationOfType(cartridge);
+		return wizardModel.getConnection().hasApplicationOfType(cartridge);
 	}
 
 	public IApplication getApplication() {
@@ -103,7 +103,7 @@
 
 	@Override
 	public IDomain getDomain() throws SocketTimeoutException, OpenShiftException {
-		return wizardModel.getUser().getDefaultDomain();
+		return wizardModel.getConnection().getDefaultDomain();
 	}
 
 	@Override
@@ -129,7 +129,7 @@
 
 	@Override
 	public Connection getUser() {
-		return wizardModel.getUser();
+		return wizardModel.getConnection();
 	}
 	
 }
Index: src/org/jboss/tools/openshift/express/internal/core/connection/ConnectionUtils.java
===================================================================
--- src/org/jboss/tools/openshift/express/internal/core/connection/ConnectionUtils.java	(revision 44557)
+++ src/org/jboss/tools/openshift/express/internal/core/connection/ConnectionUtils.java	(working copy)
@@ -59,11 +59,31 @@
 	 */
 	public static String getUrlForConnection(Connection connection) throws UnsupportedEncodingException {
 		String username = connection.getUsername();
+		String host = getHostReplaceDefault(connection);
+		String[] schemeAndHost = splitSchemeAndHostname(host);
+		return UrlUtils.toUrlString(username, schemeAndHost[1], schemeAndHost[0]);
+	}
+
+	private static String getHostReplaceDefault(Connection connection) {
 		String host = connection.getHost();
 		if (isDefaultHost(host)) {
 			host = null;
 		}
-		return UrlUtils.toUrlString(username, host, connection.getScheme());
+		return host;
+	}
+
+	private static String[] splitSchemeAndHostname(String host) {
+		if (StringUtils.isEmpty(host)) {
+			return new String[] { UrlUtils.SCHEME_HTTPS, null };
+		}
+
+		String scheme = UrlUtils.getScheme(host);
+		if (StringUtils.isEmpty(scheme)) {
+			scheme = UrlUtils.SCHEME_HTTPS;
+		} else {
+			host = UrlUtils.cutScheme(host);
+		}
+		return new String[] { scheme, host };
 	}
 
 	/**
Index: src/org/jboss/tools/openshift/express/internal/core/connection/Connection.java
===================================================================
--- src/org/jboss/tools/openshift/express/internal/core/connection/Connection.java	(revision 44557)
+++ src/org/jboss/tools/openshift/express/internal/core/connection/Connection.java	(working copy)
@@ -159,27 +159,16 @@
 	 */
 	public String getHost() {
 		if (isDefaultHost()) {
-			return ConnectionUtils.getDefaultHostUrl();
+			return UrlUtils.cutScheme(ConnectionUtils.getDefaultHostUrl());
 		}
 
 		return host;
 	}
-
-	/**
-	 * Returns the scheme of this connections. Returns https by default;
-	 * @return
-	 */
-	public String getScheme() {
-		String scheme = UrlUtils.getScheme(getHost());
-		if (StringUtils.isEmpty(scheme)) {
-			scheme = UrlUtils.HTTPS;
-		}
-		return scheme;
-	}
 	
 	public String setHost(String host) {
-		if (!UrlUtils.hasScheme(host)) {
-			host = UrlUtils.SCHEME_HTTPS + StringUtils.null2emptyString(host);
+		if (!StringUtils.isEmpty(host)
+				&& !UrlUtils.hasScheme(host)) {
+			host = UrlUtils.SCHEME_HTTPS + host;
 		}
 		this.host = host;
 		clearUser();