Index: modules/client/pom.xml
===================================================================
--- modules/client/pom.xml	(revision 16959)
+++ modules/client/pom.xml	(working copy)
@@ -9,7 +9,7 @@
   <parent>
     <groupId>org.jboss.ws.native</groupId>
     <artifactId>jbossws-native</artifactId>
-    <version>3.1.2.SP14</version>
+    <version>3.1.2.SP14-rsvoboda</version>
     <relativePath>../../pom.xml</relativePath>
   </parent>
 
Index: modules/core/pom.xml
===================================================================
--- modules/core/pom.xml	(revision 16959)
+++ modules/core/pom.xml	(working copy)
@@ -9,7 +9,7 @@
   <parent>
     <groupId>org.jboss.ws.native</groupId>
     <artifactId>jbossws-native</artifactId>
-    <version>3.1.2.SP14</version>
+    <version>3.1.2.SP14-rsvoboda</version>
     <relativePath>../../pom.xml</relativePath>
   </parent>
 
Index: modules/core/src/main/java/org/jboss/ws/tools/wsdl/WSDL11Reader.java
===================================================================
--- modules/core/src/main/java/org/jboss/ws/tools/wsdl/WSDL11Reader.java	(revision 16959)
+++ modules/core/src/main/java/org/jboss/ws/tools/wsdl/WSDL11Reader.java	(working copy)
@@ -267,7 +267,8 @@
    {
       for (File current : tempFiles)
       {
-         current.deleteOnExit();
+    	 //TODO:this will cause meomory leak if there are bunch of files to delete , look at how do do this properly
+         //current.deleteOnExit();
       }
    }
 
@@ -580,7 +581,7 @@
          }
       }
 
-      if (tmpFile != null && !tmpFile.exists())
+      if (tmpFile != null)
       {
          FileWriter fwrite = new FileWriter(tmpFile);
          new DOMWriter(fwrite).setPrettyprint(true).print(schemaEl);
Index: modules/endorsed/pom.xml
===================================================================
--- modules/endorsed/pom.xml	(revision 16959)
+++ modules/endorsed/pom.xml	(working copy)
@@ -9,7 +9,7 @@
   <parent>
     <groupId>org.jboss.ws.native</groupId>
     <artifactId>jbossws-native</artifactId>
-    <version>3.1.2.SP14</version>
+    <version>3.1.2.SP14-rsvoboda</version>
     <relativePath>../../pom.xml</relativePath>
   </parent>
 
Index: modules/management/pom.xml
===================================================================
--- modules/management/pom.xml	(revision 16959)
+++ modules/management/pom.xml	(working copy)
@@ -8,7 +8,7 @@
   <parent>
     <groupId>org.jboss.ws.native</groupId>
     <artifactId>jbossws-native</artifactId>
-    <version>3.1.2.SP14</version>
+    <version>3.1.2.SP14-rsvoboda</version>
     <relativePath>../../pom.xml</relativePath>
   </parent>
 
Index: modules/resources/pom.xml
===================================================================
--- modules/resources/pom.xml	(revision 16959)
+++ modules/resources/pom.xml	(working copy)
@@ -9,7 +9,7 @@
   <parent>
     <groupId>org.jboss.ws.native</groupId>
     <artifactId>jbossws-native</artifactId>
-    <version>3.1.2.SP14</version>
+    <version>3.1.2.SP14-rsvoboda</version>
     <relativePath>../../pom.xml</relativePath>
   </parent>
   
Index: modules/testsuite/framework-tests/pom.xml
===================================================================
--- modules/testsuite/framework-tests/pom.xml	(revision 16959)
+++ modules/testsuite/framework-tests/pom.xml	(working copy)
@@ -9,7 +9,7 @@
   <parent>
     <groupId>org.jboss.ws.native</groupId>
     <artifactId>jbossws-native-testsuite</artifactId>
-    <version>3.1.2.SP14</version>
+    <version>3.1.2.SP14-rsvoboda</version>
     <relativePath>../pom.xml</relativePath>
   </parent>
   
Index: modules/testsuite/native-tests/pom.xml
===================================================================
--- modules/testsuite/native-tests/pom.xml	(revision 16959)
+++ modules/testsuite/native-tests/pom.xml	(working copy)
@@ -9,7 +9,7 @@
   <parent>
     <groupId>org.jboss.ws.native</groupId>
     <artifactId>jbossws-native-testsuite</artifactId>
-    <version>3.1.2.SP14</version>
+    <version>3.1.2.SP14-rsvoboda</version>
     <relativePath>../pom.xml</relativePath>
   </parent>
 
Index: modules/testsuite/pom.xml
===================================================================
--- modules/testsuite/pom.xml	(revision 16959)
+++ modules/testsuite/pom.xml	(working copy)
@@ -9,7 +9,7 @@
   <parent>
     <groupId>org.jboss.ws.native</groupId>
     <artifactId>jbossws-native</artifactId>
-    <version>3.1.2.SP14</version>
+    <version>3.1.2.SP14-rsvoboda</version>
     <relativePath>../../pom.xml</relativePath>
   </parent>
 
@@ -235,6 +235,10 @@
               <name>use.hornetq</name>
               <value>${use.hornetq}</value>
             </property>
+            <property>
+              <name>org.jboss.ws.client.remoting.disconnect.after.use</name>
+              <value>false</value>
+            </property>
           </systemProperties>
         </configuration>
       </plugin>
@@ -329,6 +333,30 @@
           <groupId>org.jboss.jbossas</groupId>
           <artifactId>jboss-as-ejb3</artifactId>
           <version>${jboss.version}</version>
+
+ <exclusions>
+        <exclusion>
+          <groupId>org.jboss.aop</groupId> 
+          <artifactId>jboss-aop-aspects</artifactId>
+        </exclusion>
+        <exclusion>
+          <groupId>org.jboss.aop</groupId> 
+          <artifactId>jboss-aop-asintegration-core</artifactId>
+        </exclusion>
+        <exclusion>
+          <groupId>org.jboss.aop</groupId> 
+          <artifactId>jboss-aop-asintegration-jmx</artifactId>
+        </exclusion>
+        <exclusion>
+          <groupId>org.jboss.aop</groupId> 
+          <artifactId>jboss-aop-asintegration-mc</artifactId>
+        </exclusion>
+        <exclusion>
+          <groupId>org.jboss.aop</groupId> 
+          <artifactId>jboss-aop</artifactId>
+        </exclusion>
+      </exclusions>
+
         </dependency>
         <dependency>
           <groupId>org.jboss.jbossas</groupId>
@@ -340,6 +368,33 @@
           <artifactId>hornetq-jms-client</artifactId>
           <version>${hornetq.version}</version>
         </dependency>
+
+<dependency>
+          <groupId>org.jboss.aop</groupId> 
+          <artifactId>jboss-aop-aspects</artifactId>
+          <version>2.1.6.GA-rsvoboda</version>
+        </dependency>
+        <dependency>
+          <groupId>org.jboss.aop</groupId> 
+          <artifactId>jboss-aop-asintegration-core</artifactId>
+          <version>2.1.6.GA-rsvoboda</version>
+        </dependency>
+        <dependency>
+          <groupId>org.jboss.aop</groupId> 
+          <artifactId>jboss-aop-asintegration-jmx</artifactId>
+          <version>2.1.6.GA-rsvoboda</version>
+        </dependency>
+        <dependency>
+          <groupId>org.jboss.aop</groupId> 
+          <artifactId>jboss-aop-asintegration-mc</artifactId>
+          <version>2.1.6.GA-rsvoboda</version>
+        </dependency>
+        <dependency>
+          <groupId>org.jboss.aop</groupId> 
+          <artifactId>jboss-aop</artifactId>
+          <version>2.1.6.GA-rsvoboda</version>
+        </dependency>
+
       </dependencies>
       <build>
         <plugins>
Index: pom.xml
===================================================================
--- pom.xml	(revision 16959)
+++ pom.xml	(working copy)
@@ -17,7 +17,7 @@
   <artifactId>jbossws-native</artifactId>
   <packaging>pom</packaging>
 
-  <version>3.1.2.SP14</version>
+  <version>3.1.2.SP14-rsvoboda</version>
 
   <!-- Parent -->
   <parent>