Index: modules/core/src/main/java/org/jboss/wsf/stack/jbws/WSDLFilePublisher.java
===================================================================
--- modules/core/src/main/java/org/jboss/wsf/stack/jbws/WSDLFilePublisher.java	(revision 17026)
+++ modules/core/src/main/java/org/jboss/wsf/stack/jbws/WSDLFilePublisher.java	(working copy)
@@ -114,22 +114,22 @@
             WSDLDefinitions wsdlDefinitions = serviceMetaData.getWsdlDefinitions();
             new WSDLWriter(wsdlDefinitions).write(fWriter, Constants.DEFAULT_XML_CHARSET);
 
-            URL wsdlPublishURL = wsdlFile.toURL();
+            URL wsdlPublishURL = wsdlFile.toURI().toURL();
             log.info("WSDL published to: " + wsdlPublishURL);
 
             // udpate the wsdl file location 
-            serviceMetaData.setWsdlLocation(wsdlFile.toURL());
+            serviceMetaData.setWsdlLocation(wsdlPublishURL);
 
             // Process the wsdl imports
             Definition wsdl11Definition = wsdlDefinitions.getWsdlOneOneDefinition();
             if (wsdl11Definition != null)
             {
                List<String> published = new LinkedList<String>();
-               publishWsdlImports(wsdlFile.toURL(), wsdl11Definition, published);
+               publishWsdlImports(wsdlPublishURL, wsdl11Definition, published);
 
                // Publish XMLSchema imports
                Document document = wsdlDefinitions.getWsdlDocument();
-               publishSchemaImports(wsdlFile.toURL(), document.getDocumentElement(), published);
+               publishSchemaImports(wsdlPublishURL, document.getDocumentElement(), published);
             }
             else
             {
@@ -307,7 +307,7 @@
          else
          {
             if (file.delete() == false)
-               log.warn("Cannot delete published wsdl document: " + file.toURL());
+               log.warn("Cannot delete published wsdl document: " + file.toURI().toURL());
          }
       }
 
Index: modules/core/src/main/java/org/jboss/ws/metadata/builder/jaxws/JAXWSWebServiceMetaDataBuilder.java
===================================================================
--- modules/core/src/main/java/org/jboss/ws/metadata/builder/jaxws/JAXWSWebServiceMetaDataBuilder.java	(revision 17026)
+++ modules/core/src/main/java/org/jboss/ws/metadata/builder/jaxws/JAXWSWebServiceMetaDataBuilder.java	(working copy)
@@ -456,7 +456,7 @@
       });
       writer.close();
 
-      serviceMetaData.setWsdlLocation(wsdlFile.toURL());
+      serviceMetaData.setWsdlLocation(wsdlFile.toURI().toURL());
    }
 
    private File computeTempWsdlFile(ServiceMetaData serviceMetaData, File dir, String wsdlName) throws IOException
Index: modules/core/src/main/java/org/jboss/ws/tools/wsdl/WSDL11Reader.java
===================================================================
--- modules/core/src/main/java/org/jboss/ws/tools/wsdl/WSDL11Reader.java	(revision 17026)
+++ modules/core/src/main/java/org/jboss/ws/tools/wsdl/WSDL11Reader.java	(working copy)
@@ -547,14 +547,14 @@
          tmpFile = SchemaUtils.getSchemaTempFile(targetNS, getFileName(wsdlLoc));
          tempFiles.add(tmpFile);
 
-         publishedLocations.put(wsdlLoc, tmpFile.toURL());
+         publishedLocations.put(wsdlLoc, tmpFile.toURI().toURL());
       }
       else
       {
          tmpFile = SchemaUtils.getSchemaTempFile("no_namespace", getFileName(wsdlLoc));
          tempFiles.add(tmpFile);
 
-         publishedLocations.put(wsdlLoc, tmpFile.toURL());
+         publishedLocations.put(wsdlLoc, tmpFile.toURI().toURL());
       }
 
       // Handle schema includes
@@ -590,7 +590,7 @@
 
       if (targetNS != null)
       {
-         schemaLocationsMap.put(targetNS, tmpFile.toURL());
+         schemaLocationsMap.put(targetNS, tmpFile.toURI().toURL());
       }
       else
       {
Index: modules/core/src/main/java/org/jboss/ws/core/server/WSDLRequestHandler.java
===================================================================
--- modules/core/src/main/java/org/jboss/ws/core/server/WSDLRequestHandler.java	(revision 17026)
+++ modules/core/src/main/java/org/jboss/ws/core/server/WSDLRequestHandler.java	(working copy)
@@ -109,7 +109,7 @@
              || (wsdlPublishLoc != null 
                   && resourceAbsPath.indexOf(new File(new URL(wsdlPublishLoc).getPath()).getCanonicalPath()) >= 0))
          {
-            Element wsdlElement = DOMUtils.parse(impResourceFile.toURL().openStream());
+            Element wsdlElement = DOMUtils.parse(impResourceFile.toURI().toURL().openStream());
             wsdlDoc = wsdlElement.getOwnerDocument();
          }
          else