Index: testsuite/src/test/resources/test/consumer/META-INF/jboss.xml
===================================================================
--- testsuite/src/test/resources/test/consumer/META-INF/jboss.xml	(revision 114154)
+++ testsuite/src/test/resources/test/consumer/META-INF/jboss.xml	(working copy)
@@ -11,6 +11,12 @@
          	<ejb-class>org.jboss.ejb3.test.consumer.DeploymentDescriptorQueueTestConsumer</ejb-class>
          	<message-destination>queue/consumertest</message-destination>
 	     	<message-destination-type>javax.jms.Queue</message-destination-type>
+		<activation-config>
+		      <activation-config-property>
+		      	<activation-config-property-name>maxSession</activation-config-property-name>
+		      	<activation-config-property-value>1</activation-config-property-value>
+		      </activation-config-property>
+		</activation-config>
          	<producer>
             	<class>org.jboss.ejb3.test.consumer.DeploymentDescriptorQueueTestRemote</class>
          	</producer>
Index: testsuite/src/test/java/org/jboss/ejb3/test/consumer/TestStatusBean.java
===================================================================
--- testsuite/src/test/java/org/jboss/ejb3/test/consumer/TestStatusBean.java	(revision 114154)
+++ testsuite/src/test/java/org/jboss/ejb3/test/consumer/TestStatusBean.java	(working copy)
@@ -21,6 +21,7 @@
  */
 package org.jboss.ejb3.test.consumer;
 
+
 import javax.ejb.Remote;
 import javax.ejb.Stateless;
 
@@ -120,16 +121,23 @@
       localManager.close();
    }
    
-   public void testDeploymentDescriptorXA() throws Exception
+   public void testDeploymentDescriptorXA1() throws Exception
    {
 
       xaManagerDeploymentDescriptor.connect();
       xaDeploymentDescriptor.method1("testXA", 1);
-      Thread.sleep(1000);
-      xaDeploymentDescriptor.method2("testXA2", 4.4F);
       System.out.println("end TESTXA **");
       xaManagerDeploymentDescriptor.close();
+      Thread.sleep(1000);
    }
+   
+   public void testDeploymentDescriptorXA2() throws Exception{
+       xaManagerDeploymentDescriptor.connect();
+       xaDeploymentDescriptor.method2("testXA2", 4.4F);
+       System.out.println("end TESTXA2 **");
+       xaManagerDeploymentDescriptor.close();
+       Thread.sleep(1000);
+   }
 
    public void testDeploymentDescriptorLocal() throws Exception
    {
@@ -140,12 +148,12 @@
       localDeploymentDescriptor.method2("testLocal2", 4.4F);
       localManagerDeploymentDescriptor.close();
    }
-
+   
    public String queueFired()
    {
       return queueRan;
    }
-
+   
    public String topicFired()
    {
       return topicRan;
@@ -156,6 +164,7 @@
       return interceptedTopic;
    }
 
+   
    public String interceptedQueue()
    {
       return interceptedQueue;
Index: testsuite/src/test/java/org/jboss/ejb3/test/consumer/TestStatus.java
===================================================================
--- testsuite/src/test/java/org/jboss/ejb3/test/consumer/TestStatus.java	(revision 114154)
+++ testsuite/src/test/java/org/jboss/ejb3/test/consumer/TestStatus.java	(working copy)
@@ -50,7 +50,9 @@
 
    void testLocal() throws Exception;
    
-   void testDeploymentDescriptorXA() throws Exception;
+   void testDeploymentDescriptorXA1() throws Exception;
+   
+   void testDeploymentDescriptorXA2() throws Exception;
 
    void testDeploymentDescriptorLocal() throws Exception;
 
Index: testsuite/src/test/java/org/jboss/ejb3/test/consumer/unit/ConsumerUnitTestCase.java
===================================================================
--- testsuite/src/test/java/org/jboss/ejb3/test/consumer/unit/ConsumerUnitTestCase.java	(revision 114154)
+++ testsuite/src/test/java/org/jboss/ejb3/test/consumer/unit/ConsumerUnitTestCase.java	(working copy)
@@ -84,22 +84,12 @@
 
       //TODO: Figure out how to test preDestroy gets invoked
       //assertTrue(status.preDestroy());
-   }
-
-   public void testQueueXA() throws Exception
-   {
-      TestStatus status = (TestStatus) getInitialContext().lookup("TestStatusBean/remote");
       status.clear();
       status.testXA();
 
       Thread.sleep(1000);
       assertEquals(status.queueFired(), "method2");
       assertEquals(status.interceptedQueue(), "method2");
-   }
-
-   public void testQueueLocal() throws Exception
-   {
-      TestStatus status = (TestStatus) getInitialContext().lookup("TestStatusBean/remote");
       status.clear();
       status.testLocal();
 
@@ -140,22 +130,14 @@
 
       //TODO: Figure out how to test preDestroy gets invoked
       //assertTrue(status.preDestroy());
-   }
-   
-   public void testDeploymentDescriptorQueueXA() throws Exception
-   {
-      TestStatus status = (TestStatus) getInitialContext().lookup("TestStatusBean/remote");
       status.clear();
-      status.testDeploymentDescriptorXA();
+      status.testDeploymentDescriptorXA1();
+      status.testDeploymentDescriptorXA2();
 
       Thread.sleep(1000);
       assertEquals(status.queueFired(), "method2");
       assertEquals(status.interceptedQueue(), "method2");
-   }
-
-   public void testDeploymentDescriptorQueueLocal() throws Exception
-   {
-      TestStatus status = (TestStatus) getInitialContext().lookup("TestStatusBean/remote");
+      
       status.clear();
       status.testDeploymentDescriptorLocal();
 
@@ -183,5 +165,4 @@
          }
       };
    }
-
-}
+}
\ No newline at end of file